'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function i(t){return Object.prototype.toString.call(t)}function u(t){return n=>i(n)===`[object ${t}]`}const m=u("Number"),d=t=>m(t)&&!Number.isNaN(t);function S(t,n){return void 0!==t?t:n}const Q=(t,n)=>t+n;function D(...t){return ft(t).reduce(Q,0)}const J=D;function ft(t){return t.filter((t=>"number"==typeof t)).map((t=>t)).filter((t=>!Number.isNaN(t)))}function Ut(t){if(t.length)return t.slice(-1)[0]}function Bt(t,n){return new Array(Math.max(n,0)).fill(t)}function Wt(t){const n=Math.min(...t.map((t=>t.length))),e=[];for(let r=0;r<n;r++){const n=[];for(const e of t)n.push(e[r]);e.push(n);}return e}function In(t,n,...e){return Wt(e).map((e=>n=t(n,...e)))}function Dn(t){return Bt(NaN,t)}function Kn(t){return t.length<=0?NaN:J(...t)/t.length}function ue(t,n=NaN){return S(Ut(t),n)}this&&this.__awaiter||function(t,n,e,r){return new(e||(e=Promise))((function(i,o){function u(t){try{c(r.next(t));}catch(t){o(t);}}function s(t){try{c(r.throw(t));}catch(t){o(t);}}function c(t){var n;t.done?i(t.value):(n=t.value,n instanceof e?n:new e((function(t){t(n);}))).then(u,s);}c((r=r.apply(t,n||[])).next());}))};

const macdDefaultFastPeriod = 12;
const macdDefaultSlowPeriod = 26;
const macdDefaultSignalPeriod = 9;
function emaCore(array, period, seed) {
    const alpha = 2 / (period + 1);
    return [seed].concat(In((cascadeSeed, element) => !d(cascadeSeed)
        ? element
        : alpha * element + (1 - alpha) * cascadeSeed, seed, array));
}
function ema(array, period, seedLength = 1) {
    let i = array.findIndex(d);
    if (i < 0) {
        i = array.length;
    }
    const j = Math.min(i + seedLength - 1, array.length);
    i = Math.max(i, j);
    const meanValue = Kn(array.slice(i + 1 - seedLength, i + 1).filter(d));
    return Dn(i)
        .concat(emaCore(array.slice(i + 1), period, meanValue))
        .slice(0, array.length);
}
function macd(array, fastPeriod = 12, slowPeriod = 26, signalPeriod = 9, usePeriodAsSeedLength = false) {
    const fnEmaHelper = (a, p) => ema(a, p, usePeriodAsSeedLength ? p : 1);
    const fastEma = fnEmaHelper(array, fastPeriod);
    const slowEma = fnEmaHelper(array, slowPeriod);
    const macdArray = fastEma.map((f, i) => f - slowEma[i]);
    const signalArray = fnEmaHelper(macdArray, signalPeriod);
    return { line: macdArray, signal: signalArray };
}
function macdGetOneResult(array, fastPeriod = macdDefaultFastPeriod, slowPeriod = macdDefaultSlowPeriod, signalPeriod = macdDefaultSignalPeriod, usePeriodAsSeedLength = false) {
    const macdResult = macd(array, fastPeriod, slowPeriod, signalPeriod, usePeriodAsSeedLength);
    return {
        line: ue(macdResult.line),
        signal: ue(macdResult.signal)
    };
}

exports.ema = ema;
exports.emaCore = emaCore;
exports.macd = macd;
exports.macdDefaultFastPeriod = macdDefaultFastPeriod;
exports.macdDefaultSignalPeriod = macdDefaultSignalPeriod;
exports.macdDefaultSlowPeriod = macdDefaultSlowPeriod;
exports.macdGetOneResult = macdGetOneResult;
